
/* Maze states */
enum {
	WallUp 		= 1,
	WallRight 		= 1<<1,
	WallDown		= 1<<2,
	WallLeft		= 1<<3,
	WallExit 		= 1<<4,
	Theseus 		= 1<<5,
	Minotaur 		= 1<<6,
};

/* Movements */
enum {
	MoveUp = 0,
	MoveRight,
	MoveDown,
	MoveLeft,
	MoveEmpty,	/* no movement */
};

enum {
	MazeX = 6,
	MazeY = 6,
	Nlevels = 15,
	SizeX = 300,
	SizeY = 300,
	BoardX = 49,
	BoardY = 49,

	Numlevels = 16,
};

typedef struct {
	Point 	theseus;
	Point 	minotaur;
	Point		exit;
	uint 		board[MazeX][MazeY];
	uint 		index;
	uint		done;
} Level;

Level level;

Image *img;		/* buffer */
Image *text;		/* for text messages */
Image *win;
Image *lose;

Image *beven;		/* light coloured board */
Image *bodd;		/* dark coloured board */
Image *wall;
Image *exit;

/* images below to be used if we fancy up the game with sprites */
Image *wallh;		/* horizontal wall */
Image *wallv;		/* vertical wall */
Image *exitl;		/* exit left */
Image *exitr;		/* exit right */
Image *exitu;		/* exit up */
Image *exitd;		/* exit down */

Image *theseus;	/* our hero */
Image *minotaur;	/* our foe */
Image *dead;		/* end of game */

/* level.c */
void loadlevel(int);
void drawscreen(void);
void drawlevel(void);
void drawwin(void);
void drawdead(void);
void drawminotaur(void);
void drawtheseus(void);
void drawboard(Point p);

/* move.c */
void moveup(void);
void movedown(void);
void moveleft(void);
void moveright(void);
void moveminotaur(void);
