#include <u.h>
#include <libc.h>
#include <draw.h>

#include "maze.h"

void
moveup(void)
{
	if(level.theseus.y == 0)
		return;
	if(level.board[level.theseus.x][level.theseus.y] & WallUp)
		return;

	drawboard(level.theseus);

	level.theseus.y--;

	if(eqpt(level.theseus, level.minotaur)) 
		return;

	drawtheseus();
}

void
movedown(void)
{
	if(level.theseus.y == MazeY-1)
		return;
	if(level.board[level.theseus.x][level.theseus.y] & WallDown)
		return;

	drawboard(level.theseus);

	level.theseus.y++;

	if(eqpt(level.theseus, level.minotaur))
		return;

	drawtheseus();
}

void
moveleft(void)
{
	if(level.theseus.x == 0)
		return;
	if(level.board[level.theseus.x][level.theseus.y] & WallLeft)
		return;

	drawboard(level.theseus);

	level.theseus.x--;

	if(eqpt(level.theseus, level.minotaur))
		return;

	drawtheseus();
}

void
moveright(void)
{
	if(level.theseus.x == MazeX-1)
		return;
	if(level.board[level.theseus.x][level.theseus.y] & WallRight)
		return;

	drawboard(level.theseus);

	level.theseus.x++;

	if(eqpt(level.theseus, level.minotaur))
		return;

	drawtheseus();
}

void
moveminotaur(void)
{
	Point m, t, orig;
	int moves = 0;

	m = level.minotaur;
	t = level.theseus;

	while(moves < 2) {
		if(moves)
			sleep(300);

		orig = m;
		/* first move horizontally, then vertically */
		if((t.x > m.x) && !(level.board[m.x][m.y] & WallRight))
			m.x++; 
		else if((t.x < m.x) && !(level.board[m.x][m.y] & WallLeft))
			m.x--;
		else if((t.y > m.y) && !(level.board[m.x][m.y] & WallDown))
			m.y++;
		else if((t.y < m.y) && !(level.board[m.x][m.y] & WallUp))
			m.y--;

		moves++;
		level.minotaur = m;

		if(!eqpt(m, orig)) {
			drawboard(orig);
			drawscreen();
		} else {
			/* we haven't made a move, don't bother waiting */
			return;
		}

		if(eqpt(m, t))
			break;

		drawminotaur();
		drawscreen();
	}
}